#include <GrdAPI.h>
#include <structures.h>

#define    VERSION              3.0427
#define    USE_WHOLE_RAM        0xFFFFFFFF

class	CWritemask
{
	BYTE CurrentDongle;
	BYTE *pAlgos;
	BYTE *pAST;

public:

	BYTE IsInitialized;
	WORD wNumberOfItems;
	WORD wMaskSize;
	WORD wAST_Size;

	CWritemask(
		WORD		wDongleType,
		DWORD		dwDongleModel,
		BYTE		*pAlgos_Buffer,
		BYTE		*pAST_buffer);

	void Reinitialize(
		WORD		wDongleType,
		DWORD		dwDongleModel,
		BYTE		*pAlgos_Buffer,
		BYTE		*pAST_buffer);

	void	CODE_DET_Prepare(
		BYTE		*pMem,
		BYTE		byNumberOfCode,
		char		*szCodeMaskImage,
		DWORD		dwRAMstart,
		DWORD		dwRAMsize,
		BYTE		*pPubECCKey4Sign,
		BYTE		*pPrivECCKey4Key,
		WORD		*pwCodeDetSize);

	void	LMS_DET_Prepare(
		BYTE	*pMem,
		WORD	wFlags,
		BYTE	byLMSSize,
		WORD	wLANResource,
		WORD	wLMSModules[],
		WORD	*pwLMS_DetSize);

	void	AddAlgorithm(
		WORD			wNumericName,
		BYTE			byLoFlags,
		WORD			dwHiFlags,
		BYTE			byAlgorithmCode,
		WORD			dwKeyLength,
		WORD			dwBlockLength,
		DWORD			dwActivatePwd,
		DWORD			dwDeactivatePwd,
		DWORD			dwReadPwd,
		DWORD			dwUpdatePwd,
		TGrdTime		*pBirthTime,
		TGrdTime		*pDeadTime,
		TGrdLifeTime	*pLifeTime,
		TGrdFlipTime	*pFlipTime,
		WORD			dwGP_Counter,
		WORD			dwErrorCounter,
		BYTE			*pDet);

private:
	void	CopyData(
		BYTE	*lpvSrc,
		BYTE	*lpvDst,
		DWORD	dwLen	);

	void	AST_AddItem(
		BYTE *pPIAT_AST,
		WORD wSizeOfNewItem,
		WORD wName);
};